{$M 4000,0,64000}
uses crt,dos,graph,okna;
type Complex = record
                Re : Extended;
                Im : Extended;
               end;
var R,L,C,G,U,f,h_mez,d_mez,velikost,uhel,xp: Extended;
    zadanorlcg,chyba:boolean;
    ff:text;
    s,d,x,x1,oldx,oldy,oldp,p,krok1,krok2:integer;
    ustr,ustr1:string;
    Z0,Zk,Gama,Up : Complex;
    grDriver,k: Integer;
    grMode,code: Integer;
    ErrCode: Integer;
    z:char;
    men:mstr;
    ug:array [0..600] of extended;
    cary:array[1..10,1..2] of integer;
    str1,str1a,str1b:string;
    exc:integer;
{================= P R O C E D U R Y   A   F U N K C E ======================}
Function Re(Num:Complex):Extended;
 Begin
 Re:=Num.Re;
 End;

procedure Err;
begin
 if code<>0 then write(chr(7));
end;

Function Im(Num:Complex):Extended;
 Begin
 Im:=Num.Im;
 End;

Function Rad2St(Rad:Extended):Extended;
 Begin
  Rad2St:=Rad/Pi*180;
 End;

Function St2Rad(St:Extended):Extended;
 Begin
  St2Rad:=St/180*Pi;
 End;

Procedure Disp_sl(Num:Complex);
var zn:string;
 Begin
 if Im(num)<0 then zn:='-'
              else zn:='+';
 Write(Re(Num),' ');textcolor(white);write(zn);
 textcolor(lightgreen);write(' ',abs(Im(Num)));
 textcolor(black);write(' j');
 End;

Procedure Disp_sl1(Num:Complex);
var zn:string;
 Begin
 if Im(num)<0 then zn:='-'
              else zn:='+';
 textcolor(white);
 Write(Re(Num):10:5,' ');write(zn);
 write(' ',abs(Im(Num)):10:5);
 write(' j');
 End;

Function Vel(Num:Complex):Extended;
 Begin
 Vel:=sqrt(sqr(Re(num))+sqr(Im(Num)));
 End;

Function Uh(Num:Complex):Extended;
var pom:extended;
begin
pom:=arctan(abs(num.im)/abs(num.re));
pom:=rad2st(pom);
if (num.re>0) and (num.im<0) then pom:=-pom;
if (num.re<0) and (num.im>0) then pom:=180-pom;
if (num.re<0) and (num.im<0) then pom:=-180+pom;
uh:=pom;
end;

Procedure Disp_ex(Num:Complex);
 Begin
  Write(Vel(Num):5:5,'e^',Uh(Num):3:3)
 End;

Function ex2sl_Re(Vel,Uh:Extended):Extended;
 Begin
 uh:=st2rad(uh);
 ex2sl_Re:=Vel*cos(Uh)
 End;

Function ex2sl_Im(Vel,Uh:Extended):Extended;
 Begin
 uh:=st2rad(uh);
 ex2sl_Im:=Vel*sin(Uh)
 End;

Function Slozka(s:string):boolean;
begin
slozka:=true;
if (pos('e',s)>0) or (pos('E',s)>0) then slozka:=false
end;


Function Str_Sl2Sl_Re(s:string):Extended;
var s1,s2:string;
    n:integer;
    r1,r2:extended;
Begin
  s:=odmezer1(s);
{  if (pos('+',s)=0) and (pos('-',s)=0) then s:='+'+s;}
  n:=1;s1:='';s2:='';
  if s[1]='-' then begin s1:='-';s:=copy(s,2,length(s)-1);end;
  while (ord(s[n]) in [48..57]) or (ord(s[n]) = 46) do
   begin
    s1:=s1+s[n];n:=n+1;
   end;
  if s1='' then s1:='0';
  s2:=copy(s,n,length(s)-n);if s2='' then s2:='0';
  val(s1,r1,code);if code<>0 then chyba:=true;
  val(s2,r2,code);if code<>0 then chyba:=true;
  Str_Sl2Sl_Re:=r1;
End;

Function Str_Sl2Sl_Im(s:string):Extended;
var s1,s2:string;
    n:integer;
    r1,r2:extended;
Begin
  s:=odmezer1(s);
{  if (pos('+',s)=0) and (pos('-',s)=0) then s:='+'+s;}
  n:=1;s1:='';s2:='';
  if s[1]='-' then begin s1:='-';s:=copy(s,2,length(s)-1);end;
  while (ord(s[n]) in [48..57]) or (ord(s[n]) = 46) do
   begin
    s1:=s1+s[n];n:=n+1;
   end;
  if s1='' then s1:='0';
  s2:=copy(s,n,length(s)-n);if s2='' then s2:='0';
  val(s1,r1,code);if code<>0 then chyba:=true;
  val(s2,r2,code);if code<>0 then chyba:=true;
  Str_Sl2Sl_Im:=r2;
End;

Function Str_Ex2Sl_Vel(s:string):Extended;
var s1,s2:string;
    n:integer;
    r1,r2:extended;
Begin
  s:=odmezer1(s);n:=1;s1:='';s2:='';
{  if (pos('+',s)=0) and (pos('-',s)=0) then s:='+'+s;}
  if s[1]='-' then begin s1:='-';s:=copy(s,2,length(s)-1);end;
  while (ord(s[n]) in [48..57]) or (ord(s[n]) = 46) do
   begin
    s1:=s1+s[n];n:=n+1;
   end;
  n:=n+2;
  if s1='' then s1:='0';
  s2:=copy(s,n,length(s)-n+1);if s2='' then s2:='0';
  val(s1,r1,code);if code<>0 then chyba:=true;
  val(s2,r2,code);if code<>0 then chyba:=true;
  Str_Ex2Sl_Vel:=r1;
End;

Function Str_Ex2Sl_Uh(s:string):Extended;
var s1,s2:string;
    n:integer;
    r1,r2:extended;
Begin
  s:=odmezer1(s);
{  if (pos('+',s)=0) and (pos('-',s)=0) then s:='+'+s;}
  n:=1;s1:='';s2:='';
  if s[1]='-' then begin s1:='-';s:=copy(s,2,length(s)-1);end;
  while (ord(s[n]) in [48..57]) or (ord(s[n]) = 46) do
   begin
    s1:=s1+s[n];n:=n+1;
   end;
  n:=n+2;
  if s1='' then s1:='0';
  s2:=copy(s,n,length(s)-n+1);if s2='' then s2:='0';
  val(s1,r1,code);if code<>0 then chyba:=true;
  val(s2,r2,code);if code<>0 then chyba:=true;
  Str_Ex2Sl_Uh:=r2;
End;


Function Delit_Re(Num1,Num2:Complex):Extended;
Var N1_V,N1_U,N2_V,N2_U,Vysl_V,Vysl_U,pom:Extended;
 Begin
  N1_V:=Vel(Num1);N1_U:=Uh(Num1);N2_V:=Vel(Num2);N2_U:=Uh(Num2);
  Vysl_V:=N1_V/N2_V;Vysl_U:=N1_U-N2_U;
  pom:=ex2sl_Re(Vysl_V,Vysl_U);
  Delit_Re:=pom;
 End;

Function Delit_Im(Num1,Num2:Complex):Extended;
Var N1_V,N1_U,N2_V,N2_U,Vysl_V,Vysl_U:Extended;
 Begin
  N1_V:=Vel(Num1);N1_U:=Uh(Num1);N2_V:=Vel(Num2);N2_U:=Uh(Num2);
  Vysl_V:=N1_V/N2_V;Vysl_U:=N1_U-N2_U;
  Delit_Im:=ex2sl_Im(Vysl_V,Vysl_U);
 End;

Function Nasobit_Re(Num1,Num2:Complex):Extended;
 Begin
  Nasobit_Re:=Num1.Re*Num2.Re-Num1.Im*Num2.Im
 End;

Function Nasobit_Im(Num1,Num2:Complex):Extended;
 Begin
  Nasobit_Im:=Num1.Re*Num2.Im+Num1.Im*Num2.Re
 End;

Function SinHyp_Re(Num:Complex):Extended;
Var a,b:Extended;
 Begin
   a:=Re(Num);b:=Im(Num);
   SinHyp_Re:=((exp(a)/2)*cos(b)-1/(2*exp(a))*cos(-b));
 End;

Function SinHyp_Im(Num:Complex):Extended;
Var a,b:Extended;
 Begin
   a:=Re(Num);b:=Im(Num);
   SinHyp_Im:=((exp(a)/2)*sin(b)-1/(2*exp(a))*sin(-b));
 End;

Function CosHyp_Re(Num:Complex):Extended;
Var a,b:Extended;
 Begin
   a:=Re(Num);b:=Im(Num);
   CosHyp_Re:=((exp(a)/2)*cos(b)+1/(2*exp(a))*cos(-b));
 End;

Function CosHyp_Im(Num:Complex):Extended;
Var a,b:Extended;
 Begin
   a:=Re(Num);b:=Im(Num);
   CosHyp_Im:=((exp(a)/2)*sin(b)+1/(2*exp(a))*sin(-b));
 End;

Function TgHyp_Re(Num:Complex):Extended;
Var a,b,c,d:Extended;
 Begin
  a:=SinHyp_Re(Num);
  b:=SinHyp_Im(Num);
  c:=CosHyp_Re(Num);
  d:=CosHyp_Im(Num);
  TgHyp_Re:=(a*c+b*d)/(c*c+d*d);
 End;

Function TgHyp_Im(Num:Complex):Extended;
Var a,b,c,d:Extended;
 Begin
  a:=SinHyp_Re(Num);
  b:=SinHyp_Im(Num);
  c:=CosHyp_Re(Num);
  d:=CosHyp_Im(Num);
  TgHyp_Im:=(b*c-a*d)/(c*c+d*d);
 End;

Function sl2ex_vel(Num:Complex):extended;
var pom1,pom2,pom,pom3:extended;
begin
pom1:=num.re*num.re;
pom2:=num.im*num.im;
pom:=pom1+pom2;
pom3:=sqrt(pom);
sl2ex_vel:=pom3;
end;

Function Sl2Ex_uh(Num:Complex):extended;
var uh:extended;
begin
uh:=arctan(abs(num.im)/abs(num.re));
uh:=rad2st(uh);
if (num.re>0) and (num.im<0) then uh:=-uh;
if (num.re<0) and (num.im>0) then uh:=180-uh;
if (num.re<0) and (num.im<0) then uh:=-180+uh;
sl2ex_uh:=uh;
end;


Function odmocnina_re(Num:Complex):Extended;
var vel,uh,pom:extended;
begin
vel:=sl2ex_vel(num);
uh:=sl2ex_uh(num);
uh:=uh/2;
vel:=sqrt(vel);
pom:=ex2sl_re(vel,uh);
odmocnina_re:=ex2sl_re(vel,uh);
end;


Function odmocnina_im(Num:Complex):Extended;
var vel,uh,pom:extended;
begin
vel:=sl2ex_vel(num);
uh:=sl2ex_uh(num);
uh:=uh/2;
vel:=sqrt(vel);
pom:=ex2sl_im(vel,uh);
odmocnina_im:=pom;
end;



Procedure Upoc(f1:extended);
var omega:extended;
    g1,g2,g3:Complex;
    z3:Complex;
begin
omega:=f1*2*Pi;
g1.re:=R;  g1.im:=omega*L;
g2.re:=G;  g2.im:=omega*C;
g3.re:=Nasobit_re(g1,g2);
g3.im:=nasobit_im(g1,g2);
gama.re:=odmocnina_re(g3);
gama.im:=odmocnina_im(g3);
z3.re:=delit_re(g1,g2);
z3.im:=delit_im(g1,g2);
z0.re:=odmocnina_re(z3);
z0.im:=odmocnina_im(z3);
end;

Procedure Vzorec;
{
c1=cosh(gama*x)    c2=sinh(gama*x)    c3=tgh(gama*d)
Zpa=Zk+Z0*c3       Zpb=Z0+Zk*c3
Zp1=(Zpa/Zpb)
Zp=Z0*Zp1          Ip=Up/Zp
U1a=Up*c1          U1b=Z0*U1b1    U1b1=Ip*c1
U1=U1a-U1b
U=SQRT(U1.Re^2 + U1.Im^2)
}

Var a_c1,a_c2,a_c3,c1,c2,c3,k1,k2,Ip,Zp:Complex;
    Zpa,Zpb,Zp1,U1a,U1b,U1,U1b1:Complex;
 Begin
  a_c1.Re:=xp*Re(gama);
  a_c1.Im:=xp*Im(gama);
  c1.Re:=CosHyp_Re(a_c1);
  c1.Im:=CosHyp_Im(a_c1);
  a_c2.Re:=xp*Re(gama);
  a_c2.Im:=xp*Im(gama);
  c2.Re:=SinHyp_Re(a_c2);
  c2.Im:=SinHyp_Im(a_c2);
  a_c3.Re:=d*Re(gama);
  a_c3.Im:=d*Im(gama);
  c3.Re:=TgHyp_Re(a_c3);
  c3.Im:=TgHyp_Im(a_c3);
  Zpa.Re:=Zk.Re+Nasobit_Re(Z0,c3);
  Zpa.Im:=Zk.Im+Nasobit_Im(Z0,c3);
  Zpb.Re:=Z0.Re+Nasobit_Re(Zk,c3);
  Zpb.Im:=Z0.Im+Nasobit_Im(Zk,c3);
  Zp1.Re:=Delit_Re(Zpa,Zpb);
  Zp1.Im:=Delit_Im(Zpa,Zpb);
  Zp.Re:=Nasobit_Re(Z0,Zp1);
  Zp.Im:=Nasobit_Im(Z0,Zp1);
  Ip.Re:=Delit_Re(Up,Zp);
  Ip.Im:=Delit_Im(Up,Zp);
  U1a.Re:=Nasobit_Re(Up,c1);
  U1a.Im:=Nasobit_Im(Up,c1);
  U1b1.Re:=Nasobit_Re(Ip,c2);
  U1b1.Im:=Nasobit_Im(Ip,c2);
  U1b.Re:=Nasobit_Re(Z0,U1b1);
  U1b.Im:=Nasobit_Im(Z0,U1b1);
  U1.Re:=U1a.Re-U1b.Re;
  U1.Im:=U1a.Im-U1b.Im;
 U:=SQRT(U1.Re*U1.Re + U1.Im*U1.Im);

 End;

procedure ulozit;
begin
assign(ff,'VEDENI.SAV');
rewrite(ff);
if zadanorlcg then writeln(ff,1)
              else writeln(ff,0);
case zadanorlcg of
 true: begin
        writeln(ff,r);writeln(ff,l);
        writeln(ff,c);writeln(ff,g);
        writeln(ff,u);writeln(ff,f);
        writeln(ff,d);writeln(ff,zk.re);writeln(ff,zk.im);
       end;
 false: begin
        writeln(ff,z0.re);writeln(ff,z0.im);
        writeln(ff,gama.re);writeln(ff,gama.im);
        writeln(ff,u);writeln(ff,f);
        writeln(ff,d);writeln(ff,zk.re);writeln(ff,zk.im);
        end;
end;
close(ff);
end;

Procedure UDAJE;
begin
okno(5,17,75,23,2,2,false,'Zadane hodnoty:','');
gotoxy(1,1);
if zadanorlcg then begin
textcolor(lightred);write('    R =');textcolor(lightgreen);writeln(R);
textcolor(lightred);write('    L =');textcolor(lightgreen);writeln(L);
textcolor(lightred);write('    C =');textcolor(lightgreen);writeln(C);
textcolor(lightred);write('    G =');textcolor(lightgreen);write(G);
gotoxy(35,2);
textcolor(lightred);write('    Up =');textcolor(lightgreen);writeln(U);
gotoxy(35,3);
textcolor(lightred);write('    f  =');textcolor(lightgreen);writeln(f);
gotoxy(1,6);
textcolor(lightblue);write('    Zk =');textcolor(lightgreen);disp_sl(zk);
end
else
begin
textcolor(blue);write(' Z0   :');textcolor(lightgreen);disp_sl(z0);writeln;
textcolor(blue);write(' Gama :');textcolor(lightgreen);disp_sl(gama);
gotoxy(1,3);
textcolor(lightred);write('    Up =');textcolor(lightgreen);writeln(U);
gotoxy(1,4);
textcolor(lightred);write('    f  =');textcolor(lightgreen);writeln(f);
gotoxy(1,6);
textcolor(lightblue);write('    Zk =');textcolor(lightgreen);disp_sl(zk);
end;
ulozit;
end;

procedure nahrat;
var zadani:integer;
begin
assign(ff,'VEDENI.SAV');
reset(ff);
readln(ff,zadani);
case zadani of
 1: begin
        readln(ff,r);readln(ff,l);
        readln(ff,c);readln(ff,g);
        readln(ff,u);readln(ff,f);
        readln(ff,d);readln(ff,zk.re);readln(ff,zk.im);
        zadanorlcg:=true;
{        upoc(f);}
       end;
 0: begin
        readln(ff,z0.re);readln(ff,z0.im);
        readln(ff,gama.re);readln(ff,gama.im);
        readln(ff,u);readln(ff,f);
        readln(ff,d);readln(ff,zk.re);readln(ff,zk.im);
        zadanorlcg:=false;
{         upoc(f);}
        end;
end;
close(ff);
end;

{===================== H L A V N I   P R O G R A M ==========================}
Begin
swapvectors;
writeln('Init graphics...');
exec('graphics.com','');
swapvectors;
delay(500);
savescr('START');
{clrscr;
gama.re:=150011.0371;
gama.im:=-16811.72834;
z0.re:=odmocnina_re(gama);
z0.im:=odmocnina_im(gama);
disp_sl(z0);
{writeln(arctan(0.0001718/-0.00151));
writeln(sl2ex_uh(gama));}
{
z:=readkey;
halt(0);}


zadanorlcg:=true;
repeat
 men[1]:=' Zadani vstupnich udaju ';
 men[2]:=' Vypocet                ';
 men[3]:=' Napoveda               ';
 men[4]:=' Konec programu         ';
 textcolor(lightgray);textbackground(black);
 podklad;
 okno(10,10,33,13,red,blue,false,'Hlavni menu','');
 window(10,10,33,14);
 Nahrat;
 x:=menu(men,4,4,1);
 case x of
  1: begin
     savescr('vstup');
     repeat
     udaje;
     men[1]:=' Zadani pomoci R,L,C,G ';
     men[2]:=' Zadani pomoci Z0,gama ';
     okno(20,12,42,13,red,blue,false,'Zpusob zadani','');
     window(20,12,42,14);
     x:=menu(men,2,3,1);
     case x of
     1: begin
         savescr('vstup');
         zadanorlcg:=true;
         okno(40,10,70,18,1,1,false,'','');
         gotoxy(1,1);textcolor(lightgreen);write(' R : ');
         gotoxy(1,2);textcolor(lightgreen);write(' L : ');
         gotoxy(1,3);textcolor(lightgreen);write(' C : ');
         gotoxy(1,4);textcolor(lightgreen);write(' G : ');
         window(39,10,71,18);
         gotoxy(1,5);textcolor(white);write('Ĵ');
         window(40,10,80,20);
         gotoxy(1,6);textcolor(lightgreen);write(' Up: ');
         gotoxy(1,7);textcolor(lightgreen);write(' f : ');
         gotoxy(1,8);textcolor(lightgreen);write(' l : ');
         gotoxy(1,9);textcolor(lightgreen);write(' Zk: ');
         window(45,10,80,20);
         str1:='';
         gotoxy(1,1);
         if r<>0 then str(r:14:10,str1)
                 else str1:='0.0';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         val(str1,r,code);err;
         str1:='';
         gotoxy(1,2);
         if l<>0 then str(l:14:10,str1)
                 else str1:='0.0';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         val(str1,l,code);err;
         str1:='';
         gotoxy(1,3);
         if c<>0 then str(c:14:10,str1)
                 else str1:='0.0';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         val(str1,c,code);err;
         str1:='';
         gotoxy(1,4);
         if g<>0 then str(g:14:10,str1)
                 else str1:='0.0';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         val(str1,g,code);err;
         str1:='';
         gotoxy(1,6);
         if u<>0 then str(u:14:10,str1)
                 else str1:='0.0';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         val(str1,u,code);err;
         str1:='';
         gotoxy(1,7);
         if f<>0 then str(f:14:10,str1)
                 else str1:='0.0';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         val(str1,f,code);err;
         str1:='';
         gotoxy(1,8);
         if d<>0 then str(d,str1)
                 else str1:='0';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         val(str1,d,code);err;
         str1:='';
         gotoxy(1,9);
         str(zk.re:9:6,str1a);str(zk.Im:9:6,str1b);
         if zk.im>=0 then str1:=str1a+'+'+str1b+'j'
                    else str1:=str1a+str1b+'j';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         chyba:=false;
         case slozka(str1) of
         true: begin
               zk.Re:=Str_Sl2Sl_Re(str1);
               zk.Im:=Str_Sl2Sl_Im(str1);
               end;
         false: begin
                uhel:=Str_Ex2Sl_Uh(str1);
                velikost:=Str_Ex2Sl_Vel(str1);
               zk.Re:=ex2sl_Re(velikost,uhel);
               zk.Im:=ex2sl_Im(velikost,uhel);
                end;
         end;
         if chyba then begin write(chr(7));
                             zk.re:=0;zk.im:=0;
                             end;
         str1:='';
         upoc(f);
         loadscr('vstup');
        end;
     2: begin
         savescr('vstup');
         zadanorlcg:=false;
         okno(40,10,70,16,1,1,false,'','');
         gotoxy(1,1);textcolor(lightgreen);write(' Z0   : ');
         gotoxy(1,2);textcolor(lightgreen);write(' Gama : ');
         window(39,10,71,18);
         gotoxy(1,3);textcolor(white);write('Ĵ');
         window(40,10,80,20);
         gotoxy(1,4);textcolor(lightgreen);write(' Up: ');
         gotoxy(1,5);textcolor(lightgreen);write(' f : ');
         gotoxy(1,6);textcolor(lightgreen);write(' l : ');
         gotoxy(1,7);textcolor(lightgreen);write(' Zk: ');
         window(48,10,80,20);
         str1:='';
         gotoxy(1,1);
         str(z0.re:9:6,str1a);str(z0.Im:9:6,str1b);
         if z0.im>=0 then str1:=str1a+'+'+str1b+'j'
                    else str1:=str1a+str1b+'j';
         sed(1,0,23,str1,str1,exc);
         str1:=odmezer1(str1);
         chyba:=false;
         case slozka(str1) of
         true: begin
               z0.Re:=Str_Sl2Sl_Re(str1);
               z0.Im:=Str_Sl2Sl_Im(str1);
               end;
         false: begin
                uhel:=Str_Ex2Sl_Uh(str1);
                velikost:=Str_Ex2Sl_Vel(str1);
               z0.Re:=ex2sl_Re(velikost,uhel);
               z0.Im:=ex2sl_Im(velikost,uhel);
                end;
         end;
         if chyba then begin write(chr(7));
                             z0.re:=0;z0.im:=0;
                             end;
         str1:='';
         gotoxy(1,2);
         str(gama.re:9:6,str1a);str(gama.Im:9:6,str1b);
         if gama.im>=0 then str1:=str1a+'+'+str1b+'j'
                    else str1:=str1a+str1b+'j';
         sed(1,0,23,str1,str1,exc);
         str1:=odmezer1(str1);
         chyba:=false;
         case slozka(str1) of
         true: begin
               gama.Re:=Str_Sl2Sl_Re(str1);
               gama.Im:=Str_Sl2Sl_Im(str1);
               end;
         false: begin
                uhel:=Str_Ex2Sl_Uh(str1);
                velikost:=Str_Ex2Sl_Vel(str1);
               gama.Re:=ex2sl_Re(velikost,uhel);
               gama.Im:=ex2sl_Im(velikost,uhel);
                end;
         end;
         if chyba then begin write(chr(7));
                             gama.re:=0;gama.im:=0;
                             end;
         str1:='';
         window(45,10,80,20);
         gotoxy(1,4);
         if u<>0 then str(u:14:10,str1)
                 else str1:='0.0';
         sed(1,0,24,str1,str1,exc);
         str1:=odmezer1(str1);
         val(str1,u,code);err;
         str1:='';
         gotoxy(1,5);
         if f<>0 then str(f:14:10,str1)
                 else str1:='0.0';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         val(str1,f,code);err;
         str1:='';
         gotoxy(1,6);
         if d<>0 then str(d,str1)
                 else str1:='0';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         val(str1,d,code);err;
         str1:='';
         gotoxy(1,7);
         str(zk.re:9:6,str1a);str(zk.Im:9:6,str1b);
         if zk.im>=0 then str1:=str1a+'+'+str1b+'j'
                       else str1:=str1a+str1b+'j';
         sed(1,0,26,str1,str1,exc);
         str1:=odmezer1(str1);
         chyba:=false;
         case slozka(str1) of
         true: begin
               zk.Re:=Str_Sl2Sl_Re(str1);
               zk.Im:=Str_Sl2Sl_Im(str1);
               end;
         false: begin
                uhel:=Str_Ex2Sl_Uh(str1);
                velikost:=Str_Ex2Sl_Vel(str1);
               zk.Re:=ex2sl_Re(velikost,uhel);
               zk.Im:=ex2sl_Im(velikost,uhel);
                end;
         end;
         if chyba then begin write(chr(7));
                             zk.re:=0;zk.im:=0;
                             end;
         str1:='';
         loadscr('vystup');
        end;
     end;
     until (x=0);
     loadscr('vstup');
     x:=1;
     end;
  2: begin
     window(1,1,80,25);
up.re:=u;
up.im:=0;
h_mez:=0;
d_mez:=sqrt(sqr(Up.Re)+sqr(Up.Im));
 if zadanorlcg then upoc(f);

 textcolor(white);textbackground(black);
 clrscr;
 write('Z0   = ');
 disp_sl1(z0);
 writeln;
 textcolor(white);textbackground(black);
 write('GAMA = ');
 disp_sl1(gama);
 writeln;
 writeln;
 writeln('Stisknete ENTER...');
 kurzor(false);
 z:=readkey;


 okno(30,10,50,10,1,1,false,'','');
 gotoxy(1,1);write('Inicializace:');
 kurzor(false);
 for x1:=1 to 10 do
 begin
  cary[x1,1]:=0;
  cary[x1,2]:=0;
 end;
 x:=1;
for x1:=0 to 600 do
 begin
 gotoxy(18,1);
 xp:=(d/600*x1);
 write((x1/600*100):2:0,'%');
 Vzorec;
 if u>h_mez then h_mez:=u;
 if u<d_mez then d_mez:=u;
 ug[x1]:=u;
 if (ug[x1]>=up.re) and (ug[x1-1]<=up.re) and (x1>2) then
    begin cary[x,1]:=x1;
          cary[x,2]:=round(u);
          x:=x+1;
    end;
 if (ug[x1]<=up.re) and (ug[x1-1]>=up.re) and (x1>2) then
    begin cary[x,1]:=x1;
          cary[x,2]:=round(u);
          x:=x+1;
    end;
 end;

 s:=-1;
grDriver := Detect;
InitGraph(grDriver, grMode,' ');
ErrCode := GraphResult;
if ErrCode = grOk then
begin
  Line(0,GetMaxY-20 , GetMaxX, GetMaxY-20);
  Line(40,0,40,getmaxy);
  for x:=1 to 12 do
   begin
   str((h_mez/12*x):3:1,ustr);
   outtextxy(0,447-round(450/12*x),ustr);
   line(38,460+s-round(450/12*x),42,460+s-round(450/12*x));
   end;

  for x:=1 to 19 do
   begin
   str(round((d/20*x)):2,ustr);
   outtextxy(33+round(600/20*x),463,ustr);
   line(640-round(600/20*x),458,640-round(600/20*x),462);
   end;

  oldx:=0;
  oldy:=460+s-round(450/h_mez*ug[0]);
  moveto(oldx+40,oldy);
 for x:=0 to 600 do
     begin
     Lineto(x+40,460+s-round(450/h_mez*ug[x]));
    {  if round(450/h_mez*ug[x])<> oldy then Lineto(x+40,455-round(450/h_mez*ug[x]));}
      oldx:=x;
      oldy:=round(450/h_mez*ug[x]);
     end;
     p:=0;
  graph.setcolor(lightgreen);
  str((up.re):3:2,ustr);
  outtextxy(50,447-round(450/h_mez*up.re),ustr);
  line(30,460+s-round(450/h_mez*up.re),640,460+s-round(450/h_mez*up.re));
  graph.setcolor(lightblue);
  k:=40;
  for x:=1 to 10 do
   begin
   if cary[x,2]<>0 then
      Line(k+cary[x,1],458,k+cary[x,1],460+s-round(450/h_mez*up.re));
   end;

      str(ug[p]:7:3,ustr);
      ustr:='U='+ustr+' [V]';
      setfillstyle(1,0);
      Bar(380,470,630,480);
      graph.setcolor(lightred);
      outtextxy(380,472,ustr);
      str((d/600*p):7:2,ustr1);
      ustr1:='L='+ustr1+' [km]';
      outtextxy(500,472,ustr1);

  repeat
  z:=readkey;

  if ord(z)=0 then z:=readkey;
  oldp:=p;
  krok1:=round(600/d);
  krok2:=round(600/d*10);
  krok1:=1;
  krok2:=5;
  if ord(z)=75 then p:=p-krok1;
  if ord(z)=77 then p:=p+krok1;
  if ord(z)=115 then p:=p-krok2;
  if ord(z)=116 then p:=p+krok2;
  if p<0 then p:=0;
  if p>600 then p:=600;
  graph.setcolor(black);
  k:=40;
  Line(oldp+k,458,oldp+k,460+s-round(450/h_mez*ug[oldp]));
  Line(40,460+s-round(450/h_mez*ug[oldp]),oldp+k,460+s-round(450/h_mez*ug[oldp]));
  graph.setcolor(lightblue);
  for x:=1 to 10 do
   begin
   if cary[x,2]<>0 then
      Line(k+cary[x,1],458,k+cary[x,1],460+s-round(450/h_mez*up.re));
   end;

      str(ug[p]:7:3,ustr);
      ustr:='U='+ustr+' [V]';
      setfillstyle(1,0);
      Bar(380,470,630,480);
      graph.setcolor(lightred);
      outtextxy(380,472,ustr);
      str((d/600*p):7:2,ustr1);
      ustr1:='L='+ustr1+' [km]';
      outtextxy(500,472,ustr1);
  graph.setcolor(yellow);
  Line(p+k,458,p+k,460+s-round(450/h_mez*ug[p]));
  Line(40,460+s-round(450/h_mez*ug[p]),p+k,460+s-round(450/h_mez*ug[p]));
  graph.setcolor(white);

  Line(0,GetMaxY-20 , GetMaxX, GetMaxY-20);
  Line(40,0,40,getmaxy);
{  for x:=1 to 12 do
   begin
   str((h_mez/12*x):3:2,ustr);
   outtextxy(0,447-round(450/12*x),ustr);
   line(38,460+s-round(450/12*x),42,460+s-round(450/12*x));
   end;}

  graph.setcolor(lightgreen);
  str((up.re):3:2,ustr);
  outtextxy(50,447-round(450/h_mez*up.re),ustr);
  line(30,460+s-round(450/h_mez*up.re),640,460+s-round(450/h_mez*up.re));
  graph.setcolor(white);

  oldx:=0;
  oldy:=460+s-round(450/h_mez*ug[0]);
  moveto(oldx+40,oldy);
 for x:=0 to 600 do
     begin
     Lineto(x+40,460+s-round(450/h_mez*ug[x]));
     { if round(450/h_mez*ug[x])<> oldy then Lineto(x+40,455-round(450/h_mez*ug[x]));}
      oldx:=x;
      oldy:=round(460/h_mez*ug[x]);
     end;

  until ord(z)=27;
  x:=1;
  CloseGraph;
end
else
  Writeln('Graphics error:', GraphErrorMsg(ErrCode));
end;
3: begin
   okno(10,7,70,21,1,1,false,'','');
   kurzor(false);
   gotoxy(1,1);
   writeln('Zadavani hodnot ve tvaru:');
   writeln(' [Re] + [Im]j ...... napr.  20+30j,  45-10j');
   writeln(' [A]e^[u]     ...... napr.  20e^45,  15e^-50');
   writeln;
   writeln(' Zadani lze provest bud pomoci Z0 a gama nebo pomoci R,L,C    a G.');
   writeln;
   write(' V grafu se pohybujte pomoci sipek a Ctrl+sipek. Graf vytis-  knete na tiskarnu');
   writeln(' pomoci klavesy PrtScr (Print Screen)');
   writeln;
   writeln(' POZOR: PROGRAM JE VYUKOVY, TAKZE BUDE KOREKTNE PRACOVAT JEN         PRO SMYSLUPLNE HODNOTY!');
   writeln;
   write('        NEDIVTE SE ZE PO ZADANI NESMYSLU VRATI NESMYSL NEBO          SE UKONCI!');
   z:=readkey;
   end;
 end;
until (x=4) or (x=0);
textcolor(lightgray);textbackground(black);
clrscr;
loadscr('START');
writeln;
textcolor(lightgray);textbackground(black);clrscr;
writeln('Program VEDENI napsal Ondrej Povalac v roce 1996.');
writeln;
End.